%     VIRTUAL FABRIC - программа для получения эффективных свойств текстильных композитов
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Mesh_Generator_Procedure(Voxel_Model_Directory, Voxel_Model_Name, Analysis_Type, Work_Directory, Material_Properties, V_resin_Type, V_resin, Mechanical_Element_Type)

global ErrCode;

% Имя файла
Job_Name = 'Virtual_Fabric_RVE_mesh';

% Имя детали
Part_Name = 'FABRIC_RVE';

% --- Чтение воксельной модели ---

fprintf (1, 'Чтение воксельной модели...                             ');

[NODES, ELEMENTS, ORIENTATIONS, RVE_Coordinates, Node_Merge_Tolerance, Fout, V_resin_free] = Process_Voxel_Model(Voxel_Model_Directory, Voxel_Model_Name, Work_Directory, Job_Name, Analysis_Type, Part_Name, Mechanical_Element_Type); %#ok<ASGLU>

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% --- Вычисление объемных долей ---

fprintf (1, 'Вычисление объемных долей...                            ');

switch V_resin_Type
    
    case 'LOCAL'
        
        V_resin_local = V_resin;
        V_resin_total = (1 - V_resin_free) * V_resin_local + V_resin_free;
        
    case 'GLOBAL'
        
        V_resin_total = V_resin;
        V_resin_local = (V_resin_total - V_resin_free) / (1 - V_resin_free);
    
end

if ((V_resin_local <= 1 - pi()/(2*sqrt(3))) || (V_resin_local >= 1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: недопустимое значение локальной объемной доли связующего!\n');
    fclose(Fout);
    return;
end

fprintf (1, 'OK!\n');

fprintf (1, '\nVm_total = %g    Vm_local = %g    Vm_free = %g\n\n', V_resin_total, V_resin_local, V_resin_free);

% --- Вычисление эффективных свойств жгута ---

fprintf (1, 'Вычисление эффективных свойств жгута...\n');

Yarn_Properties = Calculate_Yarn_Properties(V_resin_local, Analysis_Type, Material_Properties, Work_Directory, 'FALSE');

if (ErrCode < 0)
    return;
end

% --- Создание сборки в выходном файле ---

fprintf (Fout, '**\n');
fprintf (Fout, '** ASSEMBLY\n');
fprintf (Fout, '**\n');

fprintf (Fout, '*Assembly, name=Assembly\n');
fprintf (Fout, '**\n');
fprintf (Fout, '*Instance, name=%s-1, part=%s\n', Part_Name, Part_Name);
fprintf (Fout, '*End Instance\n');
fprintf (Fout, '**\n');
fprintf (Fout, '*End Assembly\n');

% --- Запись свойств материала ---

fprintf (1, 'Запись свойств материала...                             ');

Write_Materials(Fout, Material_Properties, Yarn_Properties, Analysis_Type, 'ALPHA');

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% Закрытие файла
fclose(Fout);

% Сообщение об успешном создании файла с результатами
fprintf (1, '\n    Файл [%s] создан успешно!\n', [Work_Directory '\' Job_Name '.inp']);
